Add a New Solid Project

The code for this example is available on GitHub:

Supported Features

Because we are not using an Nx plugin for Solid, there are a few items we'll have to configure manually. We'll have to configure our own build system. There are no pre-created Solid-specific code generators. And we'll have to take care of updating any framework dependencies as needed.

โœ… Run Tasks โœ… Cache Task Results โœ… Share Your Cache โœ… Explore the Graph โœ… Distribute Task Execution โœ… Integrate with Editors โœ… Automate Updating Nx โœ… Enforce Module Boundaries ๐Ÿšซ Use Code Generators ๐Ÿšซ Automate Updating Framework Dependencies

Install Solid and Other Dependencies

โฏ

npm add solid-js

โฏ

npm add -D solid-devtools vite-plugin-solid

โฏ

nx add @nx/web

Create an Application

Directory Flag Behavior Changes

The command below uses the as-provided directory flag behavior, which is the default in Nx 16.8.0. If you're on an earlier version of Nx or using the derived option, omit the --directory flag. See the as-provided vs. derived documentation for more details.

We'll start with a web application and then tweak the settings to match what we need. Add a new web application to your workspace with the following command:

โฏ

nx g @nx/web:app my-solid-app --directory=apps/my-solid-app --bundler=vite

The @nx/web:app generator will create some files that are unnecessary for our Solid application.

The files and folders to be deleted are:

  • apps/my-solid-app/public/
  • apps/my-solid-app/src/app/
  • apps/my-solid-app/src/main.ts
  • apps/my-solid-app/src/styles.css
  • apps/my-solid-app/.babelrc

Turn the Application into a Solid Application

Now we'll create the files that are necessary to turn our application into a Solid application.

Add the following files

apps/my-solid-app/src/App.tsx
1import type { Component } from 'solid-js'; 2 3const App: Component = () => { 4 return ( 5 <div> 6 <header> 7 <p> 8 Edit <code>src/App.tsx</code> and save to reload. 9 </p> 10 <a 11 href="https://github.com/solidjs/solid" 12 target="_blank" 13 rel="noopener noreferrer" 14 > 15 Learn Solid Now 16 </a> 17 </header> 18 </div> 19 ); 20}; 21 22export default App; 23
apps/my-solid-app/src/index.tsx
1/* @refresh reload */ 2import { render } from 'solid-js/web'; 3 4import App from './App'; 5 6const root = document.getElementById('root'); 7 8if (import.meta.env.DEV && !(root instanceof HTMLElement)) { 9 throw new Error( 10 'Root element not found. Did you forget to add it to your index.html? Or maybe the id attribute got misspelled?' 11 ); 12} 13 14render(() => <App />, root!); 15

Update the following files

apps/my-solid-app/index.html
1<!DOCTYPE html> 2<html lang="en"> 3 <head> 4 <meta charset="utf-8" /> 5 <meta name="viewport" content="width=device-width, initial-scale=1" /> 6 <meta name="theme-color" content="#000000" /> 7 <title>Solid App</title> 8 </head> 9 <body> 10 <noscript>You need to enable JavaScript to run this app.</noscript> 11 <div id="root"></div> 12 13 <script src="src/index.tsx" type="module"></script> 14 </body> 15</html> 16
apps/my-solid-app/vite.config.ts
1/// <reference types="vitest" /> 2import { defineConfig } from 'vite'; 3import solidPlugin from 'vite-plugin-solid'; 4// import devtools from 'solid-devtools/vite'; 5 6import viteTsConfigPaths from 'vite-tsconfig-paths'; 7 8export default defineConfig({ 9 cacheDir: '../../node_modules/.vite/my-solid-app', 10 11 server: { 12 port: 3000, 13 }, 14 15 build: { 16 target: 'esnext', 17 }, 18 19 plugins: [ 20 viteTsConfigPaths({ 21 root: '../../', 22 }), 23 /* 24 Uncomment the following line to enable solid-devtools. 25 For more info see https://github.com/thetarnav/solid-devtools/tree/main/packages/extension#readme 26 */ 27 // devtools(), 28 solidPlugin(), 29 ], 30 31 // Uncomment this if you are using workers. 32 // worker: { 33 // plugins: [ 34 // viteTsConfigPaths({ 35 // root: '../../', 36 // }), 37 // ], 38 // }, 39 40 test: { 41 globals: true, 42 cache: { 43 dir: '../../node_modules/.vitest', 44 }, 45 environment: 'jsdom', 46 include: ['src/**/*.{test,spec}.{js,mjs,cjs,ts,mts,cts,jsx,tsx}'], 47 }, 48}); 49
apps/my-solid-app/tsconfig.json
1{ 2 "extends": "../../tsconfig.base.json", 3 "files": [], 4 "compilerOptions": { 5 "target": "ESNext", 6 "useDefineForClassFields": true, 7 "module": "ESNext", 8 "lib": ["ESNext", "DOM"], 9 "moduleResolution": "Node", 10 "jsx": "preserve", 11 "jsxImportSource": "solid-js", 12 "strict": true, 13 "resolveJsonModule": true, 14 "isolatedModules": true, 15 "esModuleInterop": true, 16 "noEmit": true, 17 "noUnusedLocals": true, 18 "noUnusedParameters": true, 19 "noImplicitReturns": true, 20 "skipLibCheck": true, 21 "types": ["vite/client", "vitest"] 22 }, 23 "include": ["src"], 24 "references": [ 25 { 26 "path": "./tsconfig.app.json" 27 }, 28 { 29 "path": "./tsconfig.spec.json" 30 } 31 ] 32} 33

You can now run nx serve my-solid-app and your Solid application can be viewed in your browser!

Create a Library

Directory Flag Behavior Changes

The command below uses the as-provided directory flag behavior, which is the default in Nx 16.8.0. If you're on an earlier version of Nx or using the derived option, omit the --directory flag. See the as-provided vs. derived documentation for more details.

Let's create a library that our Solid application is going to consume. To create a new library, install the @nx/js package and run:

โฏ

nx g @nx/js:lib my-lib --directory=libs/my-lib

Once the library is created, update the following files.

Rename libs/my-lib/src/lib/my-lib.ts -> libs/my-lib/src/lib/my-lib.tsx, then edit the contents to:

libs/my-lib/src/lib/my-lib.tsx
1export function MyLibComponent(props: { name: string }) { 2 return <h1>Hello {props.name} from MyLib</h1>; 3} 4
libs/my-lib/tsconfig.json
1{ 2 "extends": "../../tsconfig.base.json", 3 "compilerOptions": { 4 "module": "commonjs", 5 "forceConsistentCasingInFileNames": true, 6 "strict": true, 7 "noImplicitOverride": true, 8 "noPropertyAccessFromIndexSignature": true, 9 "noImplicitReturns": true, 10 "noFallthroughCasesInSwitch": true, 11 "jsx": "preserve", 12 "jsxImportSource": "solid-js", 13 "types": ["vitest"] 14 }, 15 "files": [], 16 "include": [], 17 "references": [ 18 { 19 "path": "./tsconfig.lib.json" 20 }, 21 { 22 "path": "./tsconfig.spec.json" 23 } 24 ] 25} 26
apps/my-solid-app/src/App.tsx
1import type { Component } from 'solid-js'; 2import { MyLibComponent } from '@acme/my-lib'; 3 4const App: Component = () => { 5 return ( 6 <div> 7 <header> 8 <p> 9 Edit <code>src/App.tsx</code> and save to reload. 10 </p> 11 <MyLibComponent name={'there'} /> 12 <a 13 href="https://github.com/solidjs/solid" 14 target="_blank" 15 rel="noopener noreferrer" 16 > 17 Learn Solid Now 18 </a> 19 </header> 20 </div> 21 ); 22}; 23 24export default App; 25

Now when you serve your application, you'll see the content from the library being displayed.

More Documentation

Add a Svelte Project

The code for this example is available on GitHub:

Supported Features

Because we are not using a Nx plugin for Svelte, there are a few items we'll have to configure manually. We'll have to configure our own build system. There are no pre-created Svelte-specific code generators. And we'll have to take care of updating any framework dependencies as needed.

โœ… Run Tasks โœ… Cache Task Results โœ… Share Your Cache โœ… Explore the Graph โœ… Distribute Task Execution โœ… Integrate with Editors โœ… Automate Updating Nx โœ… Enforce Module Boundaries ๐Ÿšซ Use Code Generators ๐Ÿšซ Automate Updating Framework Dependencies

Setup workspace

Create a new Nx workspace

โฏ

npx create-nx-workspace@latest acme --preset=ts-standalone --nx-cloud=yes

Add @nx/vite, svelte, and other dependencies to your workspace

Keep Nx Package Versions In Sync

Make sure to install the @nx/vite and @nx/js versions that matches the version of nx in your repository. If the version numbers get out of sync, you can encounter some difficult to debug errors. You can fix Nx version mismatches with this recipe.

โฏ

npm add -D vitest vite svelte svelte-check @sveltejs/vite-plugin-svelte

โฏ

nx add @nx/vite @nx/js

Create the application

Create your index.html at the root with the following:

1<!DOCTYPE html> 2<html lang="en"> 3 <head> 4 <meta charset="UTF-8" /> 5 <meta name="viewport" content="width=device-width, initial-scale=1.0" /> 6 <title>Acme</title> 7 </head> 8 <body> 9 <div id="app"></div> 10 <script type="module" src="./src/main.ts"></script> 11 </body> 12</html> 13

Navigate to src/index.ts and change it to src/main.ts and add the following content:

1import App from './App.svelte'; 2 3const app = new App({ 4 target: document.getElementById('app'), 5}); 6 7export default app; 8

Create a new file src/App.svelte and add the following content:

src/App.svelte
1<script lang="ts"> 2 let count: number = 0; 3 const increment = () => { 4 count += 1; 5 }; 6</script> 7 8<button on:click={increment}> 9 count is {count} 10</button> 11

Since we have a .svelte file, we'll need to tell typescript how to handle it. Create a new file src/svelte-shims.d.ts and add the following content:

src/svelte-shims.d.ts
1declare module '*.svelte' { 2 import type { ComponentType } from 'svelte'; 3 const component: ComponentType; 4 export default component; 5} 6

Alternatively, you could also extend the tsconfig.json file to use tsconfig/svelte.

tsconfig.json
1{ 2 "extends": "@tsconfig/svelte/tsconfig.json" 3 //... other configs 4} 5

See more here: Svelte TypeScript

Configure Nx to build and serve the application

Navigate to vite.config.ts add svelte to your plugins.

1// Add this to your imports 2import { svelte } from '@sveltejs/vite-plugin-svelte'; 3 4export default defineConfig({ 5 plugins: [ 6 //... other plugins 7 svelte(), // Add this line 8 ], 9 //... 10 server: { 11 port: 4200, 12 host: 'localhost', 13 }, 14}); 15

Change your tsconfig.lib.json to tsconfig.app.json. It should look like this:

/tsconfig.app.json
1{ 2 "extends": "./tsconfig.json", 3 "compilerOptions": { 4 "outDir": "./dist/out-tsc", 5 "declaration": true, 6 "types": ["node"] 7 }, 8 "include": ["src/**/*.ts", "src/**/*.svelte"], 9 "exclude": ["jest.config.ts", "src/**/*.spec.ts", "src/**/*.test.ts"] 10} 11

Navigate to nx.json it should contain the following:

/project.json
1{ 2 // ... other config 3 "plugins": [ 4 { 5 "plugin": "@nx/eslint/plugin", 6 "options": { 7 "targetName": "lint" 8 } 9 }, 10 { 11 "plugin": "@nx/vite/plugin", 12 "options": { 13 "buildTargetName": "build", 14 "previewTargetName": "preview", 15 "testTargetName": "test", 16 "serveTargetName": "serve", 17 "serveStaticTargetName": "serve-static" 18 } 19 } 20 ] 21} 22

We also need to add a svelte.config.js file to the project root with the following content:

1import { vitePreprocess } from '@sveltejs/vite-plugin-svelte'; 2 3export default { 4 // Consult https://svelte.dev/docs#compile-time-svelte-preprocess 5 // for more information about preprocessors 6 preprocess: vitePreprocess(), 7}; 8

Update your package.json to include:

/package.json
1{ 2 "type": "module" 3} 4
Why use the type: module?

We need to add "type": "module" to our package.json file because we are using ESM only packages. See more here: ESM Package

Test it out

Build the application

โฏ

nx build acme

Your build artifacts should be in dist/acme

Serve the application

โฏ

nx serve acme

Navigate to http://localhost:4200 and you should see your application.

Create a library

Instead of having our Counter directly defined in App.svelte file, let's create a library that we can import into our application.

Directory Flag Behavior Changes

The command below uses the as-provided directory flag behavior, which is the default in Nx 16.8.0. If you're on an earlier version of Nx or using the derived option, omit the --directory flag. See the as-provided vs. derived documentation for more details.

โฏ

nx generate @nx/js:library --name=Counter --directory=libs/counter --unitTestRunner=vitest --bundler=vite --importPath=@acme/counter

Create the Counter component at libs/counter/src/lib/Counter.svelte and copy the contents of your src/App.svelte file into it.

Update your libs/counter/src/lib/index.ts to export your Counter component.

1export { default as Counter } from './Counter.svelte'; 2
Remember the default keyword

The default is import here as due to the aliasing we'll be doing later, we'll need to import the Counter component as import { Counter } from '@acme/counter'.

Update your project's vite.config.ts to include the following:

1export default defineConfig({ 2 //... other config 3 resolve: { 4 alias: { 5 '@acme/counter': fileURLToPath( 6 new URL('/libs/counter/src/index.ts', import.meta.url) 7 ), 8 }, 9 }, 10}); 11

This allows the runtime to resolve the @acme/counter import to the correct location.

Finally update your src/App.svelte to use the counter component.

1<script lang="ts"> 2 import { Counter } from '@acme/counter'; 3</script> 4 5<Counter /> 6

Now we can build and serve our application again.

โฏ

nx build acme

To generate the build artifact at dist/acme.

โฏ

nx serve acme

To serve the application at http://localhost:4200.

More Documentation

A larger example including libraries, test and more is available at Nx Svelte Example on GitHub.